
<BOUCLE_rub(RUBRIQUES){id_rubrique}>
<div id="espace">
	<h1>#TITRE</h1>

	<div id="scene"></div>
</div>

<div id="modals">
<BOUCLE_articles(ARTICLES){id_rubrique}{par num titre, titre}>
<div id="item#ID_ARTICLE" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="itemLabel#ID_ARTICLE" aria-hidden="true">

	<div class="modal-body">
		<div class='row-fluid'>
			<div class='gauche'>
				<div class='encart image'>
					<BOUCLE_document_grand(DOCUMENTS){id_article}{mode=document}{0,1}>
					[(#FICHIER|image_reduire{800,600})]
					</BOUCLE_document_grand>
				</div>
			</div>
			<div class='droite'>
				<div class='contenu'>
					<h3 id="itemLabel#ID_ARTICLE">#TITRE</h3>
					
					[<div class='texte #EDIT{texte}'>(#TEXTE)</div>]
				</div>

			</div>
			<br class='nettoyeur' />
		</div>

	</div>
	<div class="modal-footer">
		<button class="btn" data-dismiss="modal" aria-hidden="true">
			<i class='icon-remove-sign'></i> Retour
		</button>
	</div>
</div>
</BOUCLE_articles>
</div>


<div id='lien_recommencer'>
	<button class="btn" aria-hidden="true">
		<i class='icon-refresh'></i> Recommencer
	</button>
</div>


<div id='lien_credits'>
	<a href="#credits" role="button" data-toggle="modal">
		Crédits
	</a>
</div>


<div id='credits' class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="itemCredits" aria-hidden="true">

	<div class="modal-body">
		<div class='row-fluid'>
			<div class='span6'>
				<h3 class='itemCredits'>Crédits</h3>
				[<div class='texte'>(#TEXTE)</div>]
			</div>
			<div class='span6'>
				<h4>Illustrations</h4>
				<BOUCLE_articles_credits(ARTICLES){id_rubrique}{par num titre, titre}>
					<BOUCLE_document_grand_credits(DOCUMENTS){id_article}{mode=document}{0,1}>
						[(#INCLURE{fond=modeles/credits,args=#ARRAY{
							lien,#CREDITS,
							image,#FICHIER,
							descriptif,Représente : « #_articles_credits:TITRE »
						}
						})]
					</BOUCLE_document_grand_credits>
				</BOUCLE_articles_credits>
			</div>
		</div>
	</div>
	<div class="modal-footer">
		<button class="btn" data-dismiss="modal" aria-hidden="true">
			<i class='icon-remove-sign'></i> Retour
		</button>
	</div>
</div>



<script type="text/javascript">
// calculer les tailles des modales
(function($){
$(document).ready(function(){
	sizing = function() {
		h = $(window).height() - 180;
		console.log('>> Nouvelle taille : ' + h);
		$('.modal-body').css('height', h).css('max-height', h);
		$('.modal-body .encart img').css('max-height', h - 60);
		// centrer verticalement l'image et le texte
		$('#modals .modal').each(function(){
			var $modal = $(this);
			$modal.removeClass('hide');
			setTimeout(function(){
				hd = $modal.find('.modal-body .droite .contenu').height();
				// si on a pu obtenir la taille
				if (hd && (h > hd)) {
					marge = ((h - hd) / 2) - 10;
					$modal.find('.modal-body .droite')
						.css('margin-top', marge + 'px');
				}
				hg = $modal.find('.modal-body .gauche .encart').height();
				// si on a pu obtenir la taille
				if (hg && (h > hg)) {
					marge = ((h - hg) / 2) - 10;
					$modal.find('.modal-body .gauche')
						.css('margin-top', marge + 'px');
				}
				$modal.addClass('hide');
			}, 20);
		});

	}
	// petit délai d'init…
	setTimeout(sizing, '100');
	$( window ).resize(sizing);
});
})(jQuery);
</script>

<script src="#CHEMIN{javascript/kinetic.min.js}"></script>

<script type="text/javascript">
(function($){
$(document).ready(function(){

var dessin = {}; // infos (taille du canvas)
var vignettes = {}; // infos (taille des vignettes)
var sources = [];   // sources des images
var images = [];    // images (canvas)
var formes = [];    // formes des images (conteneur recevant l'image) (pas très chouette ce nommage…)
var places = [];    // emplacements (le jeu consiste à déplacer les formes d'images dans les emplacements)
var courbes = [];   // courbes relatives à un emplacement (ça peut servir !)

var n=-1; // clés d'images
var bounds = {}; // bords de l'espace !

var kinetic_debug = [(#ENV{debug}|?{true,false})];

var aide = {}; // fonctions d'aide (underscore.js)
// random (underscore.js)
aide.random = function(min, max) {
    if (max == null) {
      max = min;
      min = 0;
    }
    return min + Math.floor(Math.random() * (max - min + 1));
};
// shuffle (underscore.js)
aide.shuffle = function(obj) {
    var rand;
    var index = 0;
    var shuffled = [];
    $.each(obj, function(key, value) {
      rand = aide.random(index++);
      shuffled[index - 1] = shuffled[rand];
      shuffled[rand] = value;
    });
    return shuffled;
};


/**
	Calcule l'espace de travail du canvas
	Calcule la taille des vignettes
*/
function calculer_tailles() {
	// donner toute la hauteur de l'écran disponible
	$('#espace').height(window.innerHeight);


	// hauteur et largeur du conteneur
	dessin.width  = $('#espace').width();
	dessin.height = $('#espace').height() - 10;

	// obtenir la taille du fond de carte en px
	dessin.carte = {};
	dessin.carte.width = 1 * $('#espace').css('background-size').replace('px','');
	dessin.carte.height = dessin.carte.width * 10 / 16;
	// debut de la carte par rapport au dessin
	dessin.carte.pos = {};
	dessin.carte.pos.x = (dessin.width  - dessin.carte.width) / 2;
	dessin.carte.pos.y = (dessin.height - dessin.carte.height) / 2;

	// taille des vignettes
	#SET{vignette_width, 200}
	#SET{vignette_height, 200}

	// vignettes images
	vignettes.proportions = 16; // 1/n-ième de la taille de l'écran
	vignettes.width = Math.round(dessin.height/(vignettes.proportions * 10))*10;
	vignettes.height = vignettes.width;
	vignettes.border = {};
	vignettes.border.size = 5;
	// vignettes emplacements
	vignettes.places = {};
	vignettes.places.width  = vignettes.width + 5;
	vignettes.places.height = vignettes.height + 5;
	vignettes.places.border = {};
	vignettes.places.border.size = vignettes.border.size;
	// ecart entre image et emplacement
	vignettes.ecarts = {};
	vignettes.ecarts.x = (vignettes.places.width - vignettes.width) / 2;
	vignettes.ecarts.y = (vignettes.places.height - vignettes.height) / 2;

	// nombre de vignettes dans 1 colonne
	vignettes.colonne = {}
	vignettes.colonne.nb = vignettes.proportions - 5;
	vignettes.colonne.nb = 10;

	// calculer les bords (éviter que les déplacement d'objets ne s'en aille de l'espace)
	bounds.marge = 10;
	bounds.minX = vignettes.border.size + bounds.marge;
	bounds.minY = vignettes.border.size + bounds.marge;
	bounds.maxX = dessin.width  - vignettes.width - vignettes.border.size - bounds.marge;
	bounds.maxY = dessin.height - vignettes.height - vignettes.border.size - bounds.marge;
}


/** redessiner les images et emplacements, avec une transition ouverture/fermeture */
function redessiner() {
	$('#espace').animate({
		'opacity': 0
	}, 300, function(){
		dessiner();
		$('#espace').animate({
				'opacity': 1
		}, 300);
	});
}


/** dessiner les images et emplacements */
function dessiner() {

	calculer_tailles();

	// espace de travail du canvas
	var scene = new Kinetic.Stage({
		container: "scene",
		width: dessin.width,
		height: dessin.height
	});

	// calque (peut y en avoir plusieurs)
	var calque_images = new Kinetic.Layer();
	var calque_places = new Kinetic.Layer();


	// gestion du DEBUG/info : sur double clic
	// affiche les coordonnées de la souris 
	if (kinetic_debug) {
		var calque_debug = new Kinetic.Layer();
		calque_debug.width(scene.width());
		calque_debug.height(scene.height());

		var groupDebug = new Kinetic.Group({x: 0, y: 0});
		calque_debug.add(groupDebug);

		var debugPoint = new Kinetic.Circle({
			x: 0,
			y: 0,
			radius: 4,
			fill: 'rgba(255,186,52,1)'
		});
		groupDebug.add(debugPoint);

		var debugText = new Kinetic.Text({
			x: 30,
			y: 0,
			text: 'Mode debug !',
			fontSize: 16,
			fontFamily: 'Calibri',
			fill: '#333',
		});
		groupDebug.add(debugText);

		var debugRect = new Kinetic.Rect({
			x: 20,
			y: -10,
			stroke: 'rgba(255,186,52,.9)',
			strokeWidth: 2,
			fill: 'rgba(255,213,131,.9)',
			width: debugText.width(),
			height: debugText.height(),
			cornerRadius: 2
		});
		debugRect.width(debugText.width() + 20);
		debugRect.height(debugText.height() + 20);
		groupDebug.add(debugRect);
		debugText.moveToTop();

		var debugStage = new Kinetic.Rect({
			x:0, y:0,
			width: dessin.width,
			height: dessin.height,
			fill: 'rgba(255,255,255,0.1)',
		});
		calque_debug.add(debugStage);

		scene.add(calque_debug);

		calque_debug.on('dblclick', function(evt){
			// console.log(evt);
			calque_debug.moveToTop();
			var x = evt.layerX;
			var y = evt.layerY;
			var carteX = x - dessin.carte.pos.x;
			var carteY = y - dessin.carte.pos.y;
			var cartePX = Math.round(carteX / dessin.carte.width * 1000) / 10;
			var cartePY = Math.round(carteY / dessin.carte.height * 1000) / 10;
			groupDebug.x(x);
			groupDebug.y(y);
			debugText.text(
				"Layer  : " + x + " / " + y + " (px) \n" +
				"Carte  : " + carteX + " / " + carteY + " (px) \n" +
				"En %   : " + cartePX + " / " + cartePY + " (%)"
			);
			debugRect.width(debugText.width() + 20);
			debugRect.height(debugText.height() + 20);
			calque_debug.draw();
		});
	}


	// placement des images sur une forme
	$.each(aide.shuffle(images), function(key, data) {

		// 2 colonnes si plus de 5 éléments)
		if (key < vignettes.colonne.nb) {
			var x = 30;
			var y = 50 + key * (vignettes.height * 1.2);
		} else {
			var x = dessin.width - vignettes.width - 30;
			var y = 50 + (key - vignettes.colonne.nb) * (vignettes.height * 1.2);
		}

		// utiliser le véritable index des images (non l'index du shuffle)
		key = data.key;

		formes[key] = new Kinetic.Image({
			image: data,

			x: x,
			y: y,

			width: vignettes.width,
			height: vignettes.height,

			fill: 'rgba(255,255,255,0.8)',
			stroke: 'rgba(0,0,0,.5)',
			strokeWidth: vignettes.border.size,
			// shadow ne fonctionne pas bien avec les images
			// cornerRadius: 10, // ne fonctionne pas avec Image

			draggable:true,

			// détection de barrières
			dragBoundFunc: function(pos) {
				var X=pos.x;
				var Y=pos.y;
				if (X<bounds.minX){X=bounds.minX;}
				if (X>bounds.maxX){X=bounds.maxX;}
				if (Y<bounds.minY){Y=bounds.minY;}
				if (Y>bounds.maxY){Y=bounds.maxY;}
				return({x:X, y:Y});
			}
		});

		// un nom pour nous
		formes[key].reference = data.data.article;

		// sauver ses coordonnées d'origine
		formes[key].origine = {};
		formes[key].origine.x = x;
		formes[key].origine.y = y;

		// cette image a validé son emplacement ?
		formes[key].valide = false;

		formes[key].on('click tap', function() {
			if (this.valide) {
				// ouvrir la modale
				$('#item' + this.reference).modal('show');
			}
		});

		formes[key].on('mouseover touchstart', function() {
			document.body.style.cursor = 'pointer';
			// on peut le déplacer tant qu'il n'a pas été validé
			// ie: qu'il a attérit à son bon emplacement
			if (!this.valide) {
				this.setStroke('rgba(255,30,0,.8)');
				calque_images.draw();
			}
		});

		formes[key].on('mouseout touchstop', function() {
			document.body.style.cursor = 'default';
			if (!this.valide) {
				this.setStroke('rgba(0,0,0,.5)');
				calque_images.draw();
			}
		});


		formes[key].on('dragstart', function() {
			this.moveToTop();
		});


		formes[key].on('dragmove', function() {
			// reference de l'objet
			var ref = this.reference;

			// emplacement actuellement survolé le plus proche
			pSurvol = imageMoveHoverNearestPlace(this);

			// décoration de ces emplacements
			if (pSurvol && !pSurvol.valide) {
				pSurvol.setStroke('rgba(255,30,0,.8)');

				// si c'est le bon emplacement que l'on survole
				if (pSurvol.reference == ref) {
					pSurvol.setStroke('rgba(30,250,0,.8)');
				}
				calque_places.draw();
			}
			if (pSurvol !== this.survol) {
				if (this.survol) {
					this.survol.setStroke('rgba(255,255,255,.9)');
					calque_places.draw();
				}
			}
			// reaffecter seulement si on ne survole pas un emplacement déjà actif
			if (!pSurvol || !pSurvol.valide) {
				this.survol = pSurvol;
			}
		});

		formes[key].on('dragend', function() {
			// reference de l'objet
			var ref = this.reference;

			// emplacement actuellement survolé le plus proche
			pSurvol = imageMoveHoverNearestPlace(this);

			// on s'est arrêté sur le bon emplacement
			if (pSurvol && !pSurvol.valide && (pSurvol.reference == ref)) {
					// on valide cet élément : on ne pourra plus y toucher
					pSurvol.valide = true;
					this.valide = true;
					this.setDraggable(false);
					// remettre le curseur normal
					document.body.style.cursor = 'default';

					tween = new Kinetic.Tween({
						node: this, 
						duration: .1,
						x: pSurvol.getAbsolutePosition().x + vignettes.ecarts.x,
						y: pSurvol.getAbsolutePosition().y + vignettes.ecarts.y,
						onFinish: function() {
							// enlever la bordure de notre image (pour prendre celle de l'emplacement uniquement)
							this.node.strokeEnabled(false);
							// ouvrir la modale
							$('#item' + this.node.reference).modal('show');
						}
					});
					tween.play();
			}
			
			// on s'est arrêté nulle part ou sur un mauvais emplacement !
			// on ramène notre image à son point de départ…
			else {
				tween = new Kinetic.Tween({
					node: this, 
					duration: .2,
					x: this.origine.x,
					y: this.origine.y,
					onFinish: function() {
						// recalculer les hover
						this.node.fire('dragmove');
					}
				});
				tween.play();
			}
		});

		calque_images.add( formes[key] );
	});

	// Ici on dessine le calque !
	scene.add(calque_images);


	// placement des emplacements (qui doivent accueillir les formes, déplacées à la souris/main)
	$.each(formes, function(key, data) {
		// x et y (positions) sont données par l'article, qui indique un % de x et y de la carte
		var pos = sources[key].pos;
		// listes des coordonnées d'emplacements possibles (si indiqué).
		var possibles = sources[key].places;

		// ça c'est la où l'emplacement (le centre de la croix) est
		var coord = {};
		coord.x = (pos.x / 100) * dessin.carte.width + dessin.carte.pos.x;
		coord.y = (pos.y / 100) * dessin.carte.height + dessin.carte.pos.y;

		// regroupement des petits (croix, courbe, carré)
		var group = new Kinetic.Group({
			x: coord.x,
			y: coord.y
		});
		calque_places.add( group );

		var circle = new Kinetic.Circle({
			x: 0,
			y: 0,
			radius: vignettes.width / 6,
			fill: 'white',
		});
		group.add(circle);
/*
		// croix
		var ligne = new Kinetic.Line({
			points: [-randomNumberCroix(), -randomNumberCroix(), randomNumberCroix(), randomNumberCroix()],
			stroke: 'white',
			strokeWidth: 5,
			lineCap: 'round',
			lineJoin: 'round',
			rotationDeg: randomNumber(0, 40)
		});
		group.add(ligne);
		var ligne = new Kinetic.Line({
			points: [-randomNumberCroix(), randomNumberCroix(), randomNumberCroix(), -randomNumberCroix()],
			stroke: 'white',
			strokeWidth: 5,
			lineCap: 'round',
			lineJoin: 'round',
			rotationDeg: randomNumber(0, 40)
		});
		group.add(ligne);
*/
		// eviter de placer l'emplacement autour de la croix (chevauchements)
		var eviter_taille = vignettes.places.width;
		var eviter = new Kinetic.Rect({
			x: -eviter_taille/2,
			y: -eviter_taille/2,

			width: eviter_taille,
			height: eviter_taille,
		});
		group.add(eviter);

		// tester un décallage 
		decalage = {};

		// soit des coordonnées sont fournies
		if (possibles.length) {
			n = randomNumber(0, possibles.length);
			var coord_place = {};
			coord_place.percent_x = possibles[n][0];
			coord_place.percent_y = possibles[n][1];
			coord_place.x = (coord_place.percent_x / 100) * dessin.carte.width + dessin.carte.pos.x;
			coord_place.y = (coord_place.percent_y / 100) * dessin.carte.height + dessin.carte.pos.y;
			decalage.x = coord_place.x - coord.x;
			decalage.y = coord_place.y - coord.y;
			decalage.def = possibles[n];
		// soit on met à gauche du point
		} else {
			decalage.x = -vignettes.places.width  * 1.5;
			decalage.y = -vignettes.places.height / 2;
			decalage.def = null;
		}

		// carré (recevant l'image)
		places[key] = new Kinetic.Rect({
			x: decalage.x,
			y: decalage.y,

			width: vignettes.places.width,
			height: vignettes.places.height,

			fill: 'rgba(255,255,255,0.5)',
			stroke: 'rgba(255,255,255,1)',
			strokeWidth: vignettes.places.border.size,
		});

		// définition des possibilités du placement
		places[key].def = decalage.def;

		// un nom pour nous
		places[key].reference = data.reference;

		// cet emplacement a été validé par une image ?
		places[key].valide = false;

		// liens croisés
		places[key].forme_liee = data;
		data.place_liee = places[key];

		group.add(places[key]);

		// on place la courbe entre la croix et l'emplacement
		var info = calculer_points_courbe(places[key]);
		var courbe = new Kinetic.Line({
			points: info.points,
			stroke: 'white',
			strokeWidth: 4,
			lineCap: 'round',
			tension: info.tension,
			dash: [10, 10]
		});

		courbes[key] = courbe;

		group.add(courbe);
		courbe.moveToBottom();

		// sauver la courbe sur l'emplacement pour la retrouver
		places[key].courbe_liee = courbe;

	});

	scene.add(calque_places);

	// mettre les images au dessus !
	calque_images.moveToTop();

}

/** retourne la liste des points de la courbe (entre la croix et l'emplacement) */
function calculer_points_courbe(place) {
	var x = place.getX();
	var y = place.getY();
	var w = place.getWidth();
	var h = place.getHeight();

	var angle = Math.atan2((y + h/2), (x + w/2)) * 180 / Math.PI;
	var abs_angle = Math.abs(angle);

	var start    = {x:0, y:0};
	var control  = {x:0, y:0};

	var end     = {};
	var espace = 15;
	var tension = 1;
	var simple = {}; 
	simple.tension = .8;
	simple.ratio = { a: 3/5, b: 1/5 }

	// interpretation de l'angle
	var boussole = ''; // nno, noo, see…
	var fin = '';  // indique (n,s,o,e) où se trouve le point de fin par rapport à l'emplacement

	// est-ce un point spécifique dont on peut avoir d'autres infos ?
	var def = place.def;

	if (def !== null) {
		console.log('passe ' + def);
		if (typeof def[2] !== 'undefined') {
			fin = def[2];
			boussole = 'définie à ' + fin;
		}
	}

	if (!fin) {

		if ((angle <= 0) && (angle > -45)) {
			boussole = 'nee';
			fin = 's';
		}
		if (angle <= -135) {
			boussole = 'noo';
			fin = 's';
		}
		if ((angle > 0) && (angle < 45)) {
			boussole = 'see';
			fin = 'n';
		}
		if (angle >= 135) {
			boussole = 'soo';
			fin = 'n';
		}
		if ((angle <= -45) && (angle > -90)) {
			boussole = 'nne';
			fin = 'o';
		}
		if ((angle >= 45) && (angle < 90)) {
			boussole = 'sse';
			fin = 'o';
		}
		if ((angle <= -90) && (angle > -135)) {
			boussole = 'nno';
			fin = 'e';
		}
		if ((angle >= 90) && (angle < 135)) {
			boussole = 'sso';
			fin = 'e';
		}
	}

	// en gros on essaie de faire une belle courbe selon où est décalé l'emplacement

	// nee, noo
	if (fin == 's') {
		end.x   = x + w/2;
		end.y   = y + h;
		control.x = end.x / 2;
		control.y = Math.max(0, end.y) + 40;
		// simplifier la courbe si la case est loin de l'origine
		// espace d'au moins une case entre le 0 et le point final
		if (end.y + h / 2 <= 0) {
			console.log('simplification ' + boussole);
			control.x = simple.ratio.a * end.x;
			control.y = simple.ratio.b * end.y;
			tension = simple.tension;
		} 
	}

	// see, soo
	if (fin == 'n') {
		end.x   = x + w/2;
		end.y   = y;
		control.x = end.x / 2;
		control.y = Math.min(0, end.y) - 40;
		// simplifier la courbe si la case est loin de l'origine
		// espace d'au moins une case entre le 0 et le point final
		if (end.y - h / 2 >= 0) {
			console.log('simplification ' + boussole);
			control.x = simple.ratio.a * end.x;
			control.y = simple.ratio.b * end.y;
			tension = simple.tension;
		} 
	}

	// nne, sse
	if (fin == 'o') {
		end.x = x;
		end.y = y + h/2;
		control.x = Math.min(0, end.x) - 40;
		control.y = end.y / 2;
		// simplifier la courbe si la case est loin de l'origine
		// espace d'au moins une case entre le 0 et le point final
		if (end.x - w / 2 >= 0) {
			console.log('simplification ' + boussole);
			control.x = simple.ratio.b * end.x;
			control.y = simple.ratio.a * end.y;
			tension = simple.tension;
		} 
	}

	// nno, sso
	if (fin == 'e') {
		end.x = x + w;
		end.y = y + h/2;
		control.x = Math.max(0, end.x) + 40;
		control.y = end.y / 2;
		// simplifier la courbe si la case est loin de l'origine
		// espace d'au moins une case entre le 0 et le point final
		if (end.x + w / 2 <= 0) {
			console.log('simplification ' + boussole);
			control.x = simple.ratio.b * end.x;
			control.y = simple.ratio.a * end.y;
			tension = simple.tension;
		} 
	}


	var points = [
		start.x,start.y,
		control.x,control.y,
		end.x,end.y
	];

	points = $.map(points, roundPoint);

	return { points: points, tension: tension }
}

function roundPoint(n) {
	return Math.round(n * 10) / 10;
}

/** retourne un nombre aléatoire pour dessiner la croix */
function randomNumberCroix() {
	return randomNumber(8, 15);
}

/** retourne un nombre aléatoire entre min et max */
function randomNumber(min, max) {
	return Math.floor(Math.random()*(max-min)) + min;
}


/** Teste qu'une image (sa forme) chevauche un emplacement, et retourne le plus proche survolé
  @param forme
      Dessin de l'image
  @return place
      Emplacement survolé le plus proche, sinon false
*/
function imageMoveHoverNearestPlace(forme) {
	var survols = imageMoveHoverPlaces(forme);
	if (!survols) return false;
	if (survols.length == 1) {
		return survols[0];
	}
	var min = false;
	var res = false;
	$(survols).each(function(key,survol) {
		var distance = distanceRectangles(forme, survol);
		if ((min === false) || (min > distance)) {
			min = distance;
			res = survol;
		} 
	});
	return res;
}

/**
  Teste qu'une image (sa forme) chevauche un emplacement
  @param forme Dessin de l'image
  @return array Liste des emplacements survolés
*/
function imageMoveHoverPlaces(forme) {
	var res = [];
	$(places).each(function(key,place){
		if (theyAreColliding(forme, place)) {
			res.push(place);
		}
	});
	return res;
}


/** Test de collision entre deux rectangles */
function theyAreColliding(rect1, rect2) {
	var r1 = rect1.getAbsolutePosition();
	var r2 = rect2.getAbsolutePosition();
	console.log(r1, r2);
	return !(r2.x > r1.x + rect1.getWidth() ||  //
			 r2.x + rect2.getWidth() < r1.x ||  // 
			 r2.y > r1.y + rect1.getHeight() ||   //
			 r2.y + rect2.getHeight() < r1.y);  //
}


/** Calcule la distance entre 2 centres de rectangles */
function distanceRectangles(rect1, rect2) {
	var r1 = rect1.getAbsolutePosition();
	var r2 = rect2.getAbsolutePosition();

	var x1 = r1.x + rect1.getWidth() / 2;
	var x2 = r2.x + rect2.getWidth() / 2;
	var y1 = r1.y + rect1.getHeight() / 2;
	var y2 = r2.y + rect2.getHeight() / 2;

	var x = Math.abs(x2 - x1);
	var y = Math.abs(y2 - y1);
	return Math.sqrt(x*x + y*y);
}


/**
 * Charge les descriptions des données, les images utilisées
 * et lance le dessin une fois que tout est fait
 */
function demarrer() {
	<BOUCLE_articles_data(ARTICLES){id_rubrique}{par num titre, titre}>
	<BOUCLE_document_data(DOCUMENTS){id_article}{mode=document}{0,1}>
	sources[ ++n ] = {
		img: '[(#FICHIER|image_reduire{#GET{vignette_width},#GET{vignette_height}}|extraire_attribut{src})]',
		article: #ID_ARTICLE,
		document: #ID_DOCUMENT,
		titre: '[(#_articles_data:TITRE|attribut_html)]',
	};
	sources[n].pos = {};
	sources[n].pos.x = #POS_X;
	sources[n].pos.y = #POS_Y;
	sources[n].places = [(#_articles_data:DATA*|trim|sinon{"\[\]"})];
	</BOUCLE_document_data>
	</BOUCLE_articles_data>

	var done = 0;

	// données de nos images (balise IMG...)
	$.each(sources, function(key, data){
		images[ key ] = new Image();
		images[ key ].key = key; // conserver la position, même si on mélange (pour cibler dans le html)
		images[ key ].src = data.img;
		images[ key ].onload = function() {
			// lorsque toutes les images sont chargées, dessiner…
			if (++done > n) {
				dessiner();
			}
		}; // si besoin…
		images[ key ].data = data;
	});
}

if (kinetic_debug) {
	window.console && console.info("Mode debug");
}

demarrer();
// redessiner le canvas lors d'un changement de taille
$( window ).resize(dessiner);
// recommencer lors de l'appui du bouton pour ça
$('#lien_recommencer').click(redessiner);


// Toutes les 2 minutes d'inactivité,
// fermer une éventuelle modale ouverte et redessiner… 
idleTime = 0;

// Increment the idle time counter every minute.
setInterval(timerIncrement, 60000); // 1 minute

// Zero the idle timer on mouse movement.
$(this).mousemove(function () { idleTime = 0; });
$(this).keypress (function () { idleTime = 0; });

function timerIncrement() {
	if (++idleTime > 1) { // 2 minutes
		// fermer les modales
		$('.modal').each(function(){
			$(this).modal('hide');
		});
		// redessiner();
	}
}


});
})(jQuery);
</script>

<!-- pour HTTrack pour qu'il voient les images à télécharger ! -->
<div class='hide'>
	<BOUCLE_articles_data_httrack(ARTICLES){id_rubrique}{par num titre, titre}>
	<BOUCLE_document_data_httrack(DOCUMENTS){id_article}{mode=document}{0,1}>
	[(#FICHIER|image_reduire{#GET{vignette_width},#GET{vignette_height}})<br />]
	</BOUCLE_document_data_httrack>
	</BOUCLE_articles_data_httrack>
</div>
</BOUCLE_rub>


